/*******************************************************************************
 *    : HelloWin.C
 *    : C ü
 *    : WinMain - Win32 Entry Point.
 *          WndProc - Windows Procedure.
 *    :    GUI ø̼ ...
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.11.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
#include <windows.h>
#include "DllBasicDecl.h"
#include "DelayImp.h"

#define UNLOAD_TEST

//#pragma comment(lib, "DelayImp.lib")
//#pragma comment(linker, "/Delayload:DllBasic.dll")
//#pragma comment(linker, "/Delay:unload")
//#pragma comment(linker, "/Delay:nobind")

TCHAR g_szAppName[] = TEXT("GUI Application using Delay-Loaded DLL");
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
#ifdef UNLOAD_TEST
TCHAR g_szDLModName[] = TEXT("DllBasicDecl");
#endif

/*******************************************************************************
 *    : WIN32 Ʈ Ʈ c
 *    : 
 *    : WinMain
 *    : HINSTANCE hInstance [IN] :  μ νϽ ڵ(۹)
 *          HINSTANCE hPrevInst [IN] :  0, (16Ʈ ȣȯ )
 *          PSTR      szCmdLine [IN] : Ŀǵ  з
 *          int       iCmdShow  [IN] : 찡  
 *   ȯ : int : 
 *    : WIN32 Ʈ Ʈ c
 *          ܼ α׷(main) ٸ GUI WinMain Ʈ Ʈ
 *          Լ νѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst,
                   PSTR szCmdLine, int iCmdShow)
{
	static TCHAR szAppName[] = TEXT("DelayLoad");
	HWND         hWnd;
	MSG          msg;
	WNDCLASS     wndclass;

	////////////////////////////////////////////////////////////////////////////
	// Ŭ 
	////////////////////////////////////////////////////////////////////////////
	wndclass.style         = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = szAppName;

	if(!RegisterClass(&wndclass))
	{
		MessageBox(NULL, TEXT("This program requires Windows NT!"),
				  szAppName, MB_ICONERROR) ;
		return 0 ;
	}
	////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////
	// 
	////////////////////////////////////////////////////////////////////////////
	hWnd = CreateWindow(szAppName,					// window class name
						TEXT("Delay-Load DLL Test"),// window caption
						WS_OVERLAPPEDWINDOW,		// window style
						CW_USEDEFAULT,              // initial x position
						CW_USEDEFAULT,              // initial y position
						400,						// initial x size
						150,						// initial y size
						NULL,                       // parent window handle
						NULL,                       // window menu handle
						hInstance,                  // program instance handle
						NULL) ;                     // creation parameters

	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	//޽ 
	////////////////////////////////////////////////////////////////////////////
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	////////////////////////////////////////////////////////////////////////////

	return msg.wParam;
}
////////////////////////////////////////////////////////////////////////////////

#ifdef UNLOAD_TEST
void IsModuleLoaded(PCTSTR pszModuleName)
{
	HMODULE hModule = GetModuleHandle(pszModuleName);
	TCHAR szOut[512];

	if(hModule)
		wsprintf(szOut, " \"%s\" εǾ ֽϴ.", pszModuleName);
	else
		wsprintf(szOut, " \"%s\" εǾ  ʽϴ.", pszModuleName);

	MessageBox(NULL, szOut, TEXT("ε ׽Ʈ"), MB_OK|MB_ICONINFORMATION);
}
#endif

/*******************************************************************************
 *    :  ν Լ(ݹ Լ)
 *    : 
 *    : WndProc
 *    : HWND   hWnd   [IN] : ޽   ڵ
 *           UINT   uMsg   [IN] : ޽
 *           WPARAM wParam [IN] : 1
 *           LPARAM lParam [IN] : 2
 *   ȯ : LRESULT : 
 *    :  ν
 *          WINDOWCLASS lpfnWndProc ʵ忡  Լ  ؾ Ѵ.
 *             Լ  ƮѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HDC         hDC;
	PAINTSTRUCT ps;
	RECT        rc;
	static char szOutBuf[] = 
		TEXT("The Most Simple Windows GUI Program by YHD.");

	switch(uMsg)
	{
		case WM_LBUTTONDOWN	:
		{
#ifdef UNLOAD_TEST
			IsModuleLoaded(g_szDLModName);
#endif

			TCHAR szOutMsg[128];
			HDC hDC = GetDC(hWnd);
			POINT pt;

			pt.x = LOWORD(lParam), pt.y = HIWORD(lParam);
			wsprintf(szOutMsg, TEXT("Mouse Position => X : %d, Y : %d"), 
					 pt.x, pt.y);
			DrawTextPos04(hDC, szOutMsg, pt);
			ReleaseDC(hWnd, hDC);
		}
		return 0;

		case WM_RBUTTONDOWN	:
		{
#ifdef UNLOAD_TEST
			IsModuleLoaded(g_szDLModName);
#endif
			HDC hDC = GetDC(hWnd);
			SIZE si = CalcTextWidth06(hDC, szOutBuf);
			ReleaseDC(hWnd, hDC);

			TCHAR szMsg[128];
			wsprintf(szMsg, 
				TEXT("Width : %d, Height : %d pixels"), si.cx, si.cy);
			MessageBox(hWnd, szMsg, g_szAppName, MB_OK|MB_ICONINFORMATION);
		}
		return 0;

		case WM_LBUTTONDBLCLK	:
		{
			__FUnloadDelayLoadedDLL2("DllBasicDecl.dll");
#ifdef UNLOAD_TEST
			IsModuleLoaded(g_szDLModName);
#endif
		}
		return 0;

		case WM_PAINT:
			hDC = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rc);
			DrawText(hDC, 
					 szOutBuf, 
					 lstrlen(szOutBuf), 
					 &rc, 
					 DT_SINGLELINE|DT_CENTER|DT_VCENTER);
			EndPaint (hWnd, &ps) ;
		return 0;

		case WM_DESTROY:
			PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
////////////////////////////////////////////////////////////////////////////////