/*******************************************************************************
 *    : HelloDll.Cpp
 *    : Cpp ü
 *    : DllMain - Win32 DLL Entry Point.
 *          DrawTextPos04   - DLL ͽƮ ׽Ʈ 04
 *          CalcTextWidth06 - DLL ͽƮ ׽Ʈ 06
 *          IsPointInRect11 - DLL ͽƮ ׽Ʈ 09
 *    :    GUI ø̼ ...
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.11.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
#include "Windows.h"

#define DLLENTRYPOINT_API extern "C" __declspec(dllexport)
#include "DllEntryPoint.h"

/*******************************************************************************
 *    : WIN32 DLL Ʈ Ʈ c
 *    : 
 *    : DllMain
 *    : HINSTANCE hModule    [IN] : DLL  νϽ ڵ(۹)
 *          DWORD     dwReason   [IN] :  DLL Ʈ Ʈ Լ ȣǴ
 *                                       ˷ִ ÷.
 *                                       4  ϳ :
 *                                        DLL_PROCESS_ATTACH,
 *                                        DLL_THREAD_ATTACH ,
 *                                        DLL_THREAD_DETACH ,
 *                                        DLL_PROCESS_DETACH,
 *          LPVOID    lpReserved [IN] : Ǿ ִ. ׻ NULL, Ѵ.
 *   ȯ : BOOL : TRUE  => Dll ε 
 *                 FALSE => Dll ε 
 *    : WIN32 DLL Ʈ Ʈ c
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
BOOL WINAPI DllMain(HINSTANCE hModule, DWORD dwReason, LPVOID lpReserved)
{
	LPTSTR pszReason[] = 
	{
		"DLL_PROCESS_ATTACH", "DLL_THREAD_ATTACH", 
		"DLL_THREAD_DETACH" , "DLL_PROCESS_DETACH"
	};

    switch(dwReason)
	{
	case DLL_PROCESS_ATTACH : MessageBox(NULL, pszReason[0], "DLL Entry Point", MB_OK); break;
	case DLL_THREAD_ATTACH  : MessageBox(NULL, pszReason[1], "DLL Entry Point", MB_OK); break;
	case DLL_THREAD_DETACH  : MessageBox(NULL, pszReason[2], "DLL Entry Point", MB_OK); break;
	case DLL_PROCESS_DETACH : MessageBox(NULL, pszReason[3], "DLL Entry Point", MB_OK); break;
	default					: break;
	}

    return TRUE;
}
//////////////////////////////////////////////////////////////////////////////

void WINAPI DrawTextPos04(HDC hDC, LPTSTR pszText, POINT ptPos)
{
	TextOut(hDC, ptPos.x, ptPos.y, pszText, lstrlen(pszText));
}

SIZE WINAPI CalcTextWidth06(HDC hDC, LPTSTR szText)
{
	int  nTextLen = lstrlen(szText);
	SIZE siTextSize;

	if(!GetTextExtentPoint32(hDC, szText, nTextLen, &siTextSize))
	{
		siTextSize.cx = 0;
		siTextSize.cy = 0;
	}

	return siTextSize;
}

BOOL WINAPI IsPointInRect11(RECT rcRgn, POINT ptPos)
{
	return PtInRect(&rcRgn, ptPos);
}
